//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private Scalper[] cacheScalper = null;

        private static Scalper checkScalper = new Scalper();

        /// <summary>
        /// Scalper
        /// </summary>
        /// <returns></returns>
        public Scalper Scalper()
        {
            return Scalper(Input);
        }

        /// <summary>
        /// Scalper
        /// </summary>
        /// <returns></returns>
        public Scalper Scalper(Data.IDataSeries input)
        {

            if (cacheScalper != null)
                for (int idx = 0; idx < cacheScalper.Length; idx++)
                    if (cacheScalper[idx].EqualsInput(input))
                        return cacheScalper[idx];

            Scalper indicator = new Scalper();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.SetUp();

            Scalper[] tmp = new Scalper[cacheScalper == null ? 1 : cacheScalper.Length + 1];
            if (cacheScalper != null)
                cacheScalper.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheScalper = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Scalper
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.Scalper Scalper()
        {
            return _indicator.Scalper(Input);
        }

        /// <summary>
        /// Scalper
        /// </summary>
        /// <returns></returns>
        public Indicator.Scalper Scalper(Data.IDataSeries input)
        {
            return _indicator.Scalper(input);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Scalper
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.Scalper Scalper()
        {
            return _indicator.Scalper(Input);
        }

        /// <summary>
        /// Scalper
        /// </summary>
        /// <returns></returns>
        public Indicator.Scalper Scalper(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.Scalper(input);
        }

    }
}
#endregion
